VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AnchorObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Anchors
' Class: AnchorObject
' By neophile (n_e_o_p_h_i_l_e@yahoo.com)
' 5/28/2002

Option Explicit

Private mCtl As Control  ' Control reference
Private mX As Anchor  ' X anchor
Private mY As Anchor  ' Y anchor


Public Property Let Control(vData As Control)
   Set mCtl = vData  ' Set reference
End Property
Public Property Get Control() As Control
   Set Control = mCtl  ' Return reference
End Property

Public Property Get X() As Anchor
   Set X = mX  ' Return X anchor
End Property

Public Property Get Y() As Anchor
   Set Y = mY  ' Return Y anchor
End Property

Public Sub SetAnchors(Optional ByVal XType As AnchorTypes, Optional ByVal YType As AnchorTypes)
   X.AnchorType = XType  ' Set X anchor type
   Select Case XType  ' X anchor
      Case atPosition  ' Get position
         mX.Value = mCtl.Container.Width - mCtl.Left  ' Control's left relative to form's right
      Case atSize  ' Get size
         mX.Value = mCtl.Container.Width - mCtl.Width  ' Control's right relative to form's right
   End Select
   Y.AnchorType = YType  ' Set Y anchor type
   Select Case YType  ' Y anchor
      Case atPosition  ' Get position
         mY.Value = mCtl.Container.Height - mCtl.Top  ' Control's top relative to form's bottom
      Case atSize  ' Get size
         mY.Value = mCtl.Container.Height - mCtl.Height  ' Control's bottom relative to form's bottom
   End Select
End Sub

Public Sub DoAnchors()
   On Error Resume Next  ' Ignore errors
   Select Case mX.AnchorType  ' X anchor
      Case atPosition  ' Set position
         mCtl.Left = mCtl.Container.Width - mX.Value  ' Left relative to right
         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
      Case atSize
         mCtl.Width = mCtl.Container.Width - mX.Value  ' Right relative to right
         If mCtl.Width < mX.MinValue Then mCtl.Width = mX.MinValue  ' Lower Limit
         If mCtl.Width > mX.MaxValue Then mCtl.Width = mX.MaxValue  ' Upper Limit
   End Select
   Select Case mY.AnchorType  ' Y anchor
      Case atPosition  ' Set position
         mCtl.Top = mCtl.Container.Height - mY.Value  ' Top relative to bottom
         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
      Case atSize  ' Set size
         mCtl.Height = mCtl.Container.Height - mY.Value  ' Bottom relative to bottom
         If mCtl.Height < mY.MinValue Then mCtl.Height = mY.MinValue  ' Lower limit
         If mCtl.Height > mY.MaxValue Then mCtl.Height = mY.MaxValue  ' Upper limit
   End Select
   On Error GoTo 0  ' Stop ignoring errors
End Sub


Private Sub Class_Initialize()
   Set mX = New Anchor  ' Create new anchor instance
   Set mY = New Anchor  ' Create new anchor instance
End Sub

Private Sub Class_Terminate()
   Set mX = Nothing  ' Discard anchor instance
   Set mY = Nothing  ' Discard anchor instance
End Sub
