VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AnchorObjectList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Anchors
' Class: AnchorObjectList
' By neophile (n_e_o_p_h_i_l_e@yahoo.com)
' 5/28/2002

Option Explicit

Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Private WithEvents mForm As Form  ' Form reference
Attribute mForm.VB_VarHelpID = -1
Private mCol As Collection  ' Item collection


Public Property Let Form(vData As Form)
   Set mForm = vData  ' Set reference
End Property
Public Property Get Form() As Form
   Set Form = mForm   ' Return reference
End Property

Public Function Count() As Long
   Count = mCol.Count  ' Return anchor collection count
End Function

Public Function Item(Control As Control) As AnchorObject
   Dim lIdx As Long
   lIdx = IndexOf(Control)  ' Get position in item collection
   If lIdx = 0 Then  ' If no item was found...
      Set Item = New AnchorObject  ' ...create a new item
      Item.Control = Control  ' Set reference
      mCol.Add Item  ' Add item to collection
   Else
      Set Item = mCol(IndexOf(Control))  ' Return item from collection
   End If
End Function

Public Function IndexOf(Control As Control) As Long
   Dim l As Long
   If mCol.Count > 0 Then  ' If there are any items...
      For l = 1 To mCol.Count  ' ...loop through them
         If mCol(l) Is Control Then  ' If the refrences match...
            IndexOf = l  ' ...return its position
            Exit For  ' Stop looping
         End If
      Next
   End If
End Function

Public Sub Remove(Control As Control)
   mCol.Remove IndexOf(Control)  ' Remove item from collection
End Sub

Public Sub SetAnchors()
   Dim oAO As AnchorObject
   For Each oAO In mCol  ' Loop through items
      oAO.SetAnchors  ' Set both anchors
   Next
End Sub

Public Sub DoAnchors()
   Dim oAO As AnchorObject
   If Not (mForm Is Nothing) Then Call LockWindowUpdate(mForm.hWnd)  ' Lock repainting
   For Each oAO In mCol  ' Loop through items
      oAO.DoAnchors  ' Do both anchors
   Next
   Call LockWindowUpdate(0)  ' Unlock repainting
End Sub


Private Sub mForm_Resize()
   Me.DoAnchors  ' Do all anchors
End Sub


Private Sub Class_Initialize()
   Set mCol = New Collection  ' Create new collection
End Sub

Private Sub Class_Terminate()
   Set mCol = Nothing  ' Discard collection
End Sub

